/**
*Resource Manager class
*For working with AWS S3 buckets
**/


function ResourceManager(callback)
{

    this.bucket = 'hmsresources';
    var self = this;
    this.s3 = new AWS.S3({ region: 'us-east-1' });

    var getObjectPromise = self.s3.getObject({ Bucket: self.bucket, Key: 'contents/' }).promise();
    //function will triggern the correct callback function
    getObjectPromise.then(function(data){
       //callback();
       if ($('.view button:first').length > 0) {
           console.log("O");
           $('.view button:first').trigger('click');
       }
       else if ($('._view button:first').length > 0) {
           console.log("1");
           $('._view button:first').trigger('click');
       }
       //add the one for showing search button
       else if ($('.searchbutton').length > 0) {
           console.log("2");
           $('.searchbutton').show();
           $(document).trigger('click');
       }
       else {
           console.log("3");
           $(document).trigger('click');
       }
    },
    function(error){
      //this is the error that occurs when changing pages after an hour has elapsed???
      console.log(error);
      loadPage();
    })

    this.getResource=function(dir)
    {
       if(dir)key=dir.replace('./','');
       resource="";
       self.s3.getSignedUrl('getObject', {Bucket:self.bucket, Key:key}, function (err, url) {
          if(err){
              console.log(err);
              loadPage();
          }
          else resource=url;
       });
       return resource;
    }

    this.getFiles=function(directory,item)
    {
        var key=directory+"/";
        self.s3.listObjectsV2({Bucket:self.bucket,Prefix:key,StartAfter:key}, function(err, data) {
         if(err){
              console.log(err);
              loadPage();
          }
          else vm.directory.display(data,directory,item);
        })
    }

    this.newDirectory=function(directory,name)
    {
        var key=directory+"/"+name+"/";
        self.s3.putObject({Bucket:self.bucket, Key:key},function(err){
         if(err){
              console.log(err);
              loadPage();
          }
          else self.getFiles(directory,name);
        })
    }

    this.deleteObjects=function(directory,keys)
    {
        for(i=0;i<keys.length;i++){
          self.s3.deleteObject({Bucket:self.bucket, Key:keys[i]}, function(err, data) {
          if(err){
               console.log(err);
               window.location.reload();
           }
           else self.getFiles(directory);
          });
        }

    }

    this.pasteObjects=function(from,to,mode,items)
    {
        alert(from+" "+to+" "+mode+" ");
        for(i=0;i<items.length;i++){
          var key=from+"/"+items[i].path;
          var name=items[i].path;
          var type=items[i].type;
          self.copyRecursive(key,name,type,to);
        }
        //if mode=cut then delete 'from' object
    }

    this.copyRecursive=function(key,name,type,to){
        //alert(key+" "+type+" "+to);
        var copyto=to+"/"+name;
        alert(key+" "+copyto);
        if(type=="file"){

          self.s3.copyObject({Bucket:self.bucket,CopySource:key,Key:copyto}, function(err, data) {
             if (err) alert(err+" "+err.stack);
             else{
                 alert(JSON.stringify(data,null,2));
             }
          });

         /* var file=null;
          var contentType="";
          self.s3.getObject({Bucket:self.bucket,Key:key}, function(err, data) {
             if (err) alert(err+" "+err.stack);
             else{
                 alert(JSON.stringify(data,null,2));
                 contentType=data.ContentType;                                  
                 file=new File(data.Body.data, name, {type: contentType});
             }
          });
          var key=to+"/"+name;
          self.s3.putObject({Bucket:self.bucket,Key:key,ContentType: contentType, Body: file,ContentLength:100}, function(err, data) {
             if (err) alert(err+" "+err.stack);
             else{
                 alert("copied");
             }
          }); */
        }

    }

    this.uploadFiles=function(directory,files)
    {
         var key=directory+"/"
         for(i=0;i<files.length;i++){
            self.s3.upload({Bucket:self.bucket,Key: key+files[i].name, ContentType: files[i].type, Body: files[i]}, function (err, data) {
               if (err) alert(err+" "+err.stack);
               else{
                  self.getFiles(directory,files[files.length-1].name);
               }
            });
         }

    }

    this.savePhoto=function(video,directory,photo)
    {
         var video=video;
         var index=video.data('index');
         self.s3.upload({Bucket:self.bucket,Key: directory+"/photo"+index+".jpg", ContentType: "image/jpeg", Body: photo}, function (err, data) {
            if (err) alert(err+" "+err.stack);
            else{
               video.data('photo').updatePhoto(video.data('index'),directory+"/photo"+index+".jpg");
            }
         });

    }

    this.uploadReport=function(context,index,directory,file)
    {
          self.s3.upload({Bucket:self.bucket,Key: directory+file.name, ContentType: file.type, Body: file}, function (err, data) {
             if (err) alert(err+" "+err.stack);
             else{
                //self.getFiles(directory,files[files.length-1].name);
                context.updateReport(index,directory+file.name);
             }
          });

    }

    this.uploadNDT=function(recordid,ssiid,file)
    {
          var directory="NDT/"+recordid+"/"+ssiid+"/";
          try{
          self.s3.upload({Bucket:self.bucket,Key:directory+file.name, ContentType: file.type, Body: file, Metadata:{"Owner":username}}, function (err, data) {
             if (err) alert(err+" "+err.stack);
             else{
                uploaded(file.name,recordid,ssiid,file.size);
             }
          });
          }
          catch(e){
             alert(e);
          }

    }

    this.deleteNDT=function(key,id)
    {
       self.s3.deleteObject({Bucket:self.bucket, Key:key}, function(err, data) {
          if (err) alert(err+" "+err.stack);
          else{
             try{
             deleteFileRecord(id);
             }
             catch(e){
                alert(e);
             }
          }
       });
    }

    this.getNDTRawFiles=function(directory)
    {
        var key=directory+"/";
        self.s3.listObjectsV2({Bucket:self.bucket,Prefix:key,StartAfter:key}, function(err, data) {
           if (err) alert(err+" "+err.stack);
           else{
              alert(JSON.stringify(data.Contents));
              for(i in data.Contents){
                 self.getObject(data.Contents[i].Key);
              }
           }
        })
    }

    this.getObject=function(key)
    {
       self.s3.getObject({Bucket:self.bucket,Key:key}, function(err, data) {
          if (err) alert(err+" "+err.stack);
          else alert(JSON.stringify(data.Metadata.Owner));
       })
    }

    this.getNDTReports=function(directory,ele)
    {
        var key=directory+"/";
        self.s3.listObjectsV2({Bucket:self.bucket,Prefix:key,StartAfter:key}, function(err, data) {
           if (err) alert(err+" "+err.stack);
           else displayNDTRecords(ele,data);
        })
    }

    this.uploadNDTReports=function(recordid,ssiid,file)
    {
          var directory="NDT/"+recordid+"/"+ssiid+"/reports/";
          self.s3.upload({Bucket:self.bucket,Key:directory+file.name, ContentType: file.type, Body: file}, function (err, data) {
             if (err) alert(err+" "+err.stack);
             else{
             }
          });
    }

    this.clearNDTReports=function(key)
    {
        self.s3.listObjectsV2({Bucket:self.bucket,Prefix:key,StartAfter:key}, function(err, data) {
          if (err) alert(err+" "+err.stack);
          else{
             //alert(JSON.stringify(data));
             if (data.Contents.length > 0){
                params = {Bucket: self.bucket};
                params.Delete = {Objects:[]};
                data.Contents.forEach(function(content) {
                   params.Delete.Objects.push({Key: content.Key});
                });
                alert(JSON.stringify(params.Delete.Objects));
                try{
                self.s3.deleteObjects(params, function(err, data) {
                   if (err) alert(err+" "+err.stack);
                   else{
                      //delete top level folder
                      self.s3.deleteObject({Bucket:self.bucket, Key:key}, function(err, data) {
                         if (err) alert(err+" "+err.stack);
                         else submitFiles();
                      })
                   }
                });
                }
                catch(e){
                   alert(e)
                }
             }
             else submitFiles();
          }
        });
    }


    //update token when document is clicked
    $(document).click(function () {
        var poolData = {
            UserPoolId: 'us-east-1_l5tCBR3sI',
            ClientId: '2vuvoj0dtqku542675dee2pd7k'
        };
        var userPool = new AWSCognito.CognitoIdentityServiceProvider.CognitoUserPool(poolData);
        var cognitoUser = userPool.getCurrentUser();

        if (cognitoUser != null) {
            cognitoUser.getSession(function (err, result) {
                if (result) {
                    console.log('Clicked');
                    //userAccess = result.getIdToken().getJwtToken();
                    // Add the User's Id Token to the Cognito credentials login map.
                    AWS.config.credentials = new AWS.CognitoIdentityCredentials({
                        IdentityPoolId: 'us-east-1:1f59e4c7-fee3-42f4-bb6e-3ca5edc287cd',
                        Logins: {
                            'cognito-idp.us-east-1.amazonaws.com/us-east-1_l5tCBR3sI': result.getIdToken().getJwtToken()
                        }
                    });
                    //$(document).trigger("AWSReady");
                    //this.s3 =  new AWS.S3();
                    console.log("Cognito Update", result.getIdToken().getJwtToken());
                    awsready = true;
                }
                else {
                    console.log("NO SESSION");
                }
            });
        }
        this.s3 = new AWS.S3({ region: 'us-east-1' });
    });


}